Graphics 640,480,0

Global Original[128],OriginalSize[128]
Global Originals=-1

Global Home$=CurrentDir$()

Global TempImg
Global LaunchImg=LoadPixmapPNG("Launch.png")
GetOriginals()

quick=ReadFile("icons.ini")
Repeat
	ini$=ReadLine(quick)
	If Instr(ini$,"=")>0
		lft$=SplitText$(ini$,"=",1)
		rght$=SplitText$(ini$,"=",2)
		va=Int(SplitText(rght$,",",1))
		vb=Int(SplitText(rght$,",",2))
		
		cmd$=splittext(lft$,"/",1)
		cmdb$=splittext(lft$,"/",2)
		cmdc$=splittext(lft$,"/",3)

		If Lower$(cmd$)="icons" Then CreateIcon(cmdb$,va)
		If Lower$(cmd$)="launch" Then CreateLaunch(cmdb$,va,vb)
		If Lower$(cmd$)="android" Then CreateAndroid(cmdc$,cmdb$,va)
	EndIf
Until Eof(quick)
CloseFile quick
End






Function SplitText$(in$,Split$,e,alsospace=0)

	'Splits text...
	Local out:String=""
	Local start:Int=1
	Local nomore:Int=0
	Local shift:Int
	Local size:Int

	in:String=Trim(in)
	e=e-1
	
	For shift=1 To e
		If Instr(in$,Split$,start)+1<=nstart Then nomore=1
		If Instr(in$,Split$,start)+1>nstart Then nstart=Instr(in$,Split$,start)+1
		If AlsoSpace=1 Then If Instr(in$," ",start)+1<nstart And Instr(in$," ",start)>0 Then nstart=Instr(in$," ",start)+1
		start=nstart
	Next
	size=(Instr(in$,Split$,start))-start
	If AlsoSpace=1 Then If (Instr(in$," ",start))-start<size And Instr(in$," ",start)>0 Then size=(Instr(in$," ",start))-start
	

	out$=Mid$(in$,start,size)
	If nomore=1 Then out$="-+-"
	Return out
End Function




Function GetOriginals()
Local HasIcons=0
Local HasLaunch=0

quicky=ReadDir(CurrentDir())
Repeat
	in$=NextFile(quicky)
	If in$="icons" Then HasIcons=1
	If in$="launch" Then HasLaunch=1
	
	If (Left$(Upper$(in$),5)="ICON_" Or Left$(Upper$(in$),5)="ICON-" ) And Right$(Upper$(in$),4)=".PNG"
		Originals=Originals+1
		TempImg=LoadImage(in$)
		Original[Originals]=LoadPixmapPNG(in$)
		OriginalSize[Originals]=ImageWidth(TempImg)
		TempImg=Null
	EndIf
Until in$=""
CloseDir quicky
DebugLog((Originals+1)+" Originals loaded")

If HasIcons=0 Then CreateDir("icons")
If HasLaunch=0 Then CreateDir("launch")

End Function

Function CreateIcon(filename$,Size#)
	ChangeDir("icons/")
		Cls
			DrawText("Creating Icon ("+Int(size)+") "+CurrentDir$()+"/"+filename$,10,200)
		Flip

		MakeIcon(Size)
		If TempImg<>Null
			SavePixmapPNG(TempImg,filename$,5)
			DebugLog "Creating Icon ("+Int(size)+") "+CurrentDir$()+"/"+filename$
		EndIf		
	ChangeDir(Home$)
End Function

Function CreateLaunch(filename$,SizeX#,SizeY#)

	If LaunchImg<>Null
	ChangeDir("launch/")
		Local Size#=SizeX
		If SizeY>Size Then Size=SizeY
		Cls
			DrawText("Creating Launch Screen ("+Int(sizeX)+","+Int(SizeY)+") "+CurrentDir$()+"/"+filename$,10,200)
		Flip

		DebugLog "Creating Launch Screen ("+Int(sizeX)+","+Int(SizeY)+") "+CurrentDir$()+"/"+filename$
		TempImgb=ResizePixmap(LaunchImg,Size,Size)
		TempImg=CreatePixmap(SizeX,SizeY,PF_RGBA8888)
		cx=(Size/2)-(SizeX/2)
		cy=(Size/2)-(SizeY/2)
		For x=0 To SizeX-1
		For y=0 To SizeY-1
			ex=cx+x
			ey=cy+y
			If ex>-1 And ex<Size And ey>-1 And ey<Size 
				argb=ReadPixel(TempImgb,ex,ey)
				WritePixel(TempImg,x,y,argb)
			EndIf
			If KeyDown(1) Then End
		Next
		Next
		
		If TempImg<>Null
			SavePixmapPNG(TempImg,filename$,5)
			DebugLog("Complete")
		EndIf		
	ChangeDir(Home$)
	EndIf
End Function


Function CreateAndroid(filename$,folder$,size#)

	ChangeDir("../")
	DroidTarget$=""
	quicky=ReadDir(CurrentDir())
		Repeat
			in$=NextFile$(quicky)
			If Right$(Upper$(in$),6)=".BUILD" Then DroidTarget$=in$
		Until in$=""
	CloseDir quicky
	
	If DroidTarget$<>""
		ChangeDir(droidtarget$+"/")
		ChangeDir("android/")
		ChangeDir("res/")
		ChangeDir(folder$)
		
		MakeIcon(size)
		If TempImg<>Null
			Cls
				DrawText("Creating Android Icon ("+Int(size)+") "+CurrentDir$()+"/"+filename$,10,200)
			Flip
			SavePixmapPNG(TempImg,filename$,5)
			DebugLog "Creating Android Icon ("+Int(size)+") "+CurrentDir$()+"/"+filename$
		EndIf
	EndIf
	ChangeDir(Home$)
End Function

Function MakeIcon(Size#)
	pick=-1
	offset=1024
	For n=0 To Originals
		If Abs(OriginalSize[n]-Size)<offset Then offset=OriginalSize[n]-Size;pick=n
	Next
	
	TempImg=Null
	GCCollect()
	If pick>-1
		TempImg=ResizePixmap(Original[pick],Size,Size)
	EndIf
End Function